import de.janicke.hj.tools.StreamBeautifier;
import java.io.*;

public class Beautify {
  static StreamBeautifier bf = new StreamBeautifier();
  
  public static void main(String[] args) {
    java.io.File source=null;
    java.io.File dest=null;
    if (args.length < 2) {
      System.out.println("\nCall:\n\tjava Beautify <source> <destination> [opt1] [opt2] ...");
      System.out.println("\noptions:\n\tcols <int>\tThe column where to break lines.");
      System.out.println("\tbc\tbreak comments at col");
      System.out.println("\tbs\tbreak Strings at col");
      System.out.println("\tcompact\tC-Style { at end of line.");
      return;
    } else {
      source = new java.io.File(args[0]);
      dest = new java.io.File(args[1]);
    }
    
    if (source.exists() && source.isFile()) {
      if (dest.exists()) {
        if (dest.isDirectory()) {
          System.out.println("There is already a directory with the same name as the destination file.");
          return;
        } else {
          System.out.println("There is already a file with the same name as the destination file.");
          return;
        }
      }
    } else {
      System.out.println("Source file doesn't exist or isn't a file.");
      return;
    }

    for (int i=2; i<args.length; i++) {
      if (args[i].equals("cols")) {
        i++;
        if (i < args.length) {
          try {
            int col = Integer.parseInt(args[i]);
            if (col > 1) bf.setBreakColumn(col);
          } catch (NumberFormatException exc) {
            System.err.println("Bad optional argument:\n col must be followed by an valid int > 1.");
            return;
          }
        } else {
          System.err.println("Bad optional argument:\n col must be followed by an valid int > 1.");
          return;
        }
      } else if (args[i].equals("ind")) {
        i++;
        if (i < args.length) {
          try {
            String ind = args[i];
            for (int j=0; j < ind.length(); j++) {
              if ( !Character.isWhitespace(ind.charAt(j)) ) {
                System.err.println("Bad optional argument:\n ind must be followed by a String containing whitespace");
                return;
              }
            }
            bf.setIndent(ind);
          } catch (NumberFormatException exc) {
            System.err.println("Bad optional argument:\n col must be followed by an valid int > 1.");
            return;
          }
        } else {
          System.err.println("Bad optional argument:\n col must be followed by an valid int > 1.");
          return;
        }
      } else if (args[i].equals("bc")) {
        bf.setBreakComments(true);
      } else if (args[i].equals("bs")) {
        bf.setBreakStrings(true);
      } else if (args[i].equals("compact")) {
        bf.setStyle(StreamBeautifier.STYLE_C);
      }
    }
    try {
      String in = readFile(source);
      writeFile(dest, bf.beautify(in));
    } catch (IOException exc) {
      exc.printStackTrace();
    }
  }
  
  
  public static String readFile(File source) throws IOException {
    StringBuffer sb = new StringBuffer();
    BufferedReader br = new BufferedReader(new FileReader(source));
    String s = "";
    while ((s = br.readLine()) != null) {
      sb.append(s+"\n");
    }
    
    br.close();
    return sb.toString();
  }
  
  public static void writeFile(File dest, StringBuffer s) throws IOException {
    BufferedWriter bw = new BufferedWriter(new FileWriter(dest));
    
    bw.write(s.toString());
    bw.flush();
    bw.close();
  }
  
}
    